# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::Mgmt::V2017_07_01_preview
  module Models
    #
    # Specifies a metric to load balance a service during runtime.
    #
    class ServiceLoadMetricDescription

      include MsRestAzure

      # @return [String] The name of the metric. If the service chooses to
      # report load during runtime, the load metric name should match the name
      # that is specified in Name exactly. Note that metric names are case
      # sensitive.
      attr_accessor :name

      # @return [Enum] Possible values include: 'Zero', 'Low', 'Medium', 'High'
      attr_accessor :weight

      # @return [Integer] Used only for Stateful services. The default amount
      # of load, as a number, that this service creates for this metric when it
      # is a Primary replica.
      attr_accessor :primary_default_load

      # @return [Integer] Used only for Stateful services. The default amount
      # of load, as a number, that this service creates for this metric when it
      # is a Secondary replica.
      attr_accessor :secondary_default_load

      # @return [Integer] Used only for Stateless services. The default amount
      # of load, as a number, that this service creates for this metric.
      attr_accessor :default_load


      #
      # Mapper for ServiceLoadMetricDescription class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ServiceLoadMetricDescription',
          type: {
            name: 'Composite',
            class_name: 'ServiceLoadMetricDescription',
            model_properties: {
              name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'Name',
                type: {
                  name: 'String'
                }
              },
              weight: {
                client_side_validation: true,
                required: false,
                serialized_name: 'Weight',
                type: {
                  name: 'String'
                }
              },
              primary_default_load: {
                client_side_validation: true,
                required: false,
                serialized_name: 'PrimaryDefaultLoad',
                type: {
                  name: 'Number'
                }
              },
              secondary_default_load: {
                client_side_validation: true,
                required: false,
                serialized_name: 'SecondaryDefaultLoad',
                type: {
                  name: 'Number'
                }
              },
              default_load: {
                client_side_validation: true,
                required: false,
                serialized_name: 'DefaultLoad',
                type: {
                  name: 'Number'
                }
              }
            }
          }
        }
      end
    end
  end
end
